<pattern xmlns="http://relaxng.org/ns/structure/1.0">
<title>Cardinality of segments and titles</title>
<rule context="db:seglistitem">
<assert test="count(db:seg) = count(../db:segtitle)">The number of seg elements must be the same as the number of segtitle elements in the parent segmentedlist</assert>
</rule>
</pattern>
<pattern>
<title>Element exclusion</title>
<rule context="db:annotation">
<assert test="not(.//db:annotation)">annotation must not occur among the children or descendants of annotation</assert>
</rule>
<rule context="db:caution">
<assert test="not(.//db:caution)">caution must not occur among the children or descendants of caution</assert>
<assert test="not(.//db:important)">important must not occur among the children or descendants of caution</assert>
<assert test="not(.//db:note)">note must not occur among the children or descendants of caution</assert>
<assert test="not(.//db:tip)">tip must not occur among the children or descendants of caution</assert>
<assert test="not(.//db:warning)">warning must not occur among the children or descendants of caution</assert>
</rule>
<rule context="db:important">
<assert test="not(.//db:caution)">caution must not occur among the children or descendants of important</assert>
<assert test="not(.//db:important)">important must not occur among the children or descendants of important</assert>
<assert test="not(.//db:note)">note must not occur among the children or descendants of important</assert>
<assert test="not(.//db:tip)">tip must not occur among the children or descendants of important</assert>
<assert test="not(.//db:warning)">warning must not occur among the children or descendants of important</assert>
</rule>
<rule context="db:note">
<assert test="not(.//db:caution)">caution must not occur among the children or descendants of note</assert>
<assert test="not(.//db:important)">important must not occur among the children or descendants of note</assert>
<assert test="not(.//db:note)">note must not occur among the children or descendants of note</assert>
<assert test="not(.//db:tip)">tip must not occur among the children or descendants of note</assert>
<assert test="not(.//db:warning)">warning must not occur among the children or descendants of note</assert>
</rule>
<rule context="db:tip">
<assert test="not(.//db:caution)">caution must not occur among the children or descendants of tip</assert>
<assert test="not(.//db:important)">important must not occur among the children or descendants of tip</assert>
<assert test="not(.//db:note)">note must not occur among the children or descendants of tip</assert>
<assert test="not(.//db:tip)">tip must not occur among the children or descendants of tip</assert>
<assert test="not(.//db:warning)">warning must not occur among the children or descendants of tip</assert>
</rule>
<rule context="db:warning">
<assert test="not(.//db:caution)">caution must not occur among the children or descendants of warning</assert>
<assert test="not(.//db:important)">important must not occur among the children or descendants of warning</assert>
<assert test="not(.//db:note)">note must not occur among the children or descendants of warning</assert>
<assert test="not(.//db:tip)">tip must not occur among the children or descendants of warning</assert>
<assert test="not(.//db:warning)">warning must not occur among the children or descendants of warning</assert>
</rule>
<rule context="db:caption">
<assert test="not(.//db:caution)">caution must not occur among the children or descendants of caption</assert>
<assert test="not(.//db:equation)">equation must not occur among the children or descendants of caption</assert>
<assert test="not(.//db:example)">example must not occur among the children or descendants of caption</assert>
<assert test="not(.//db:figure)">figure must not occur among the children or descendants of caption</assert>
<assert test="not(.//db:important)">important must not occur among the children or descendants of caption</assert>
<assert test="not(.//db:note)">note must not occur among the children or descendants of caption</assert>
<assert test="not(.//db:sidebar)">sidebar must not occur among the children or descendants of caption</assert>
<assert test="not(.//db:table)">table must not occur among the children or descendants of caption</assert>
<assert test="not(.//db:task)">task must not occur among the children or descendants of caption</assert>
<assert test="not(.//db:tip)">tip must not occur among the children or descendants of caption</assert>
<assert test="not(.//db:warning)">warning must not occur among the children or descendants of caption</assert>
</rule>
<rule context="db:equation">
<assert test="not(.//db:equation)">equation must not occur among the children or descendants of equation</assert>
<assert test="not(.//db:example)">example must not occur among the children or descendants of equation</assert>
<assert test="not(.//db:figure)">figure must not occur among the children or descendants of equation</assert>
<assert test="not(.//db:table)">table must not occur among the children or descendants of equation</assert>
</rule>
<rule context="db:example">
<assert test="not(.//db:equation)">equation must not occur among the children or descendants of example</assert>
<assert test="not(.//db:example)">example must not occur among the children or descendants of example</assert>
<assert test="not(.//db:figure)">figure must not occur among the children or descendants of example</assert>
<assert test="not(.//db:table)">table must not occur among the children or descendants of example</assert>
</rule>
<rule context="db:figure">
<assert test="not(.//db:equation)">equation must not occur among the children or descendants of figure</assert>
<assert test="not(.//db:example)">example must not occur among the children or descendants of figure</assert>
<assert test="not(.//db:figure)">figure must not occur among the children or descendants of figure</assert>
<assert test="not(.//db:table)">table must not occur among the children or descendants of figure</assert>
</rule>
<rule context="db:table">
<assert test="not(.//db:equation)">equation must not occur among the children or descendants of table</assert>
<assert test="not(.//db:example)">example must not occur among the children or descendants of table</assert>
<assert test="not(.//db:figure)">figure must not occur among the children or descendants of table</assert>
</rule>
<rule context="db:footnote">
<assert test="not(.//db:caution)">caution must not occur among the children or descendants of footnote</assert>
<assert test="not(.//db:epigraph)">epigraph must not occur among the children or descendants of footnote</assert>
<assert test="not(.//db:equation)">equation must not occur among the children or descendants of footnote</assert>
<assert test="not(.//db:example)">example must not occur among the children or descendants of footnote</assert>
<assert test="not(.//db:figure)">figure must not occur among the children or descendants of footnote</assert>
<assert test="not(.//db:footnote)">footnote must not occur among the children or descendants of footnote</assert>
<assert test="not(.//db:important)">important must not occur among the children or descendants of footnote</assert>
<assert test="not(.//db:note)">note must not occur among the children or descendants of footnote</assert>
<assert test="not(.//db:sidebar)">sidebar must not occur among the children or descendants of footnote</assert>
<assert test="not(.//db:table)">table must not occur among the children or descendants of footnote</assert>
<assert test="not(.//db:task)">task must not occur among the children or descendants of footnote</assert>
<assert test="not(.//db:tip)">tip must not occur among the children or descendants of footnote</assert>
<assert test="not(.//db:warning)">warning must not occur among the children or descendants of footnote</assert>
</rule>
<rule context="db:sidebar">
<assert test="not(.//db:sidebar)">sidebar must not occur among the children or descendants of sidebar</assert>
</rule>
<rule context="db:entry">
<assert test="not(.//db:informaltable)">informaltable must not occur among the children or descendants of entry</assert>
<assert test="not(.//db:table)">table must not occur among the children or descendants of entry</assert>
</rule>
</pattern>

<pattern>
<title>Footnote reference type constraint</title>
<rule context="db:footnoteref">
<assert test="local-name(//*[@xml:id=current()/@linkend]) = 'footnote' and namespace-uri(//*[@xml:id=current()/@linkend]) = 'http://docbook.org/ns/docbook'">@linkend on footnoteref must point to a footnote.</assert>
</rule>
</pattern>

<pattern>
<title>Glossary 'firstterm' type constraint</title>
<rule context="db:firstterm[@linkend]">
<assert test="local-name(//*[@xml:id=current()/@linkend]) = 'glossentry' and namespace-uri(//*[@xml:id=current()/@linkend]) = 'http://docbook.org/ns/docbook'">@linkend on firstterm must point to a glossentry.</assert>
</rule>
</pattern>

<pattern>
<title>Glossary 'glossterm' type constraint</title>
<rule context="db:glossterm[@linkend]">
<assert test="local-name(//*[@xml:id=current()/@linkend]) = 'glossentry' and namespace-uri(//*[@xml:id=current()/@linkend]) = 'http://docbook.org/ns/docbook'">@linkend on glossterm must point to a glossentry.</assert>
</rule>
</pattern>

<pattern>
<title>Glossary 'seealso' type constraint</title>
<rule context="db:glossseealso[@otherterm]">
<assert test="local-name(//*[@xml:id=current()/@otherterm]) = 'glossentry' and namespace-uri(//*[@xml:id=current()/@otherterm]) = 'http://docbook.org/ns/docbook'">@otherterm on glossseealso must point to a glossentry.</assert>
</rule>
</pattern>

<pattern>
<title>Glossary term definition constraint</title>
<rule context="db:termdef">
<assert test="count(db:firstterm) = 1">A termdef must contain exactly one firstterm</assert>
</rule>
</pattern>

<pattern>
<title>Glosssary 'see' type constraint</title>
<rule context="db:glosssee[@otherterm]">
<assert test="local-name(//*[@xml:id=current()/@otherterm]) = 'glossentry' and namespace-uri(//*[@xml:id=current()/@otherterm]) = 'http://docbook.org/ns/docbook'">@otherterm on glosssee must point to a glossentry.</assert>
</rule>
</pattern>

<pattern>
<title>Indexterm 'startref' type constraint</title>
<rule context="db:indexterm[@startref]">
<assert test="//*[@xml:id=current()/@startref]/@class='startofrange'">@startref on indexterm must point to a startofrange indexterm.</assert>
<assert test="local-name(//*[@xml:id=current()/@startref]) = 'indexterm' and namespace-uri(//*[@xml:id=current()/@startref]) = 'http://docbook.org/ns/docbook'">@startref on indexterm must point to an indexterm.</assert>
</rule>
</pattern>

<pattern>
<title>Synopsis fragment type constraint</title>
<rule context="db:synopfragmentref">
<assert test="local-name(//*[@xml:id=current()/@linkend]) = 'synopfragment' and namespace-uri(//*[@xml:id=current()/@linkend]) = 'http://docbook.org/ns/docbook'">@linkend on synopfragmentref must point to a synopfragment.</assert>
</rule>
</pattern>

<pattern>
<title>XLink arc placement</title>
<rule context="*[@xlink:type='arc']">
<assert test="parent::*[@xlink:type='extended']">An XLink arc type element must occur as the direct child of an XLink extended type element.</assert>
</rule>
</pattern>

<pattern>
<title>XLink extended placement</title>
<rule context="*[@xlink:type='extended']">
<assert test="not(parent::*[@xlink:type='extended'])">An XLink extended type element may not occur as the direct child of an XLink extended type element.</assert>
</rule>
</pattern>

<pattern>
<title>XLink locator placement</title>
<rule context="*[@xlink:type='locator']">
<assert test="parent::*[@xlink:type='extended']">An XLink locator type element must occur as the direct child of an XLink extended type element.</assert>
</rule>
</pattern>

<pattern>
<title>XLink resource placement</title>
<rule context="*[@xlink:type='resource']">
<assert test="parent::*[@xlink:type='extended']">An XLink resource type element must occur as the direct child of an XLink extended type element.</assert>
</rule>
</pattern>

<pattern>
<title>XLink title placement</title>
<rule context="*[@xlink:type='title']">
<assert test="parent::*[@xlink:type='extended'] or parent::*[@xlink:type='locator'] or parent::*[@xlink:type='arc']">An XLink title type element must occur as the direct child of an XLink extended, locator, or arc type element.</assert>
</rule>
</pattern>

</schema>
